#include "colors.inc"
#include "glass.inc"
#include "textures.inc"

#declare unicolor = texture{
	pigment {
	bozo
	pigment_map {
		[0 brick Black,White,mortar 0.04
		rotate 90*z
		scale 0.15 ]
		[0.5 White]
		[0.95 White*0.90]
		[1 White*0.80]
	}
	scale 6
	}
	normal {bumps 0.1}
}

#declare halfviper = union {
	union {  
		box{<-3,-2,-0.1>,<15,-4,1.2>}
		difference{
  	  cylinder{<-1,-1.2,0>,<4,-1.2,0>,1.2}
  	  cylinder{<-1.1,-1.2,0>,<4.1,-1.2,0>,0.9}
  	}
		difference{
      cylinder{<-1,-3,1.5>,<4,-3,1.5>,1.2}
      cylinder{<-1.1,-3,1.5>,<4.1,-3,1.5>,0.9}
    }
    difference{
      cylinder{<-3,-1.2,0>,<-2,-1.2,0>,1.2}
      cylinder{<-3.1,-1.2,0>,<-1.9,-1.2,0>,0.9}
    }
    difference
    {
      cylinder{<-3,-3,1.5>,<-2,-3,1.5>,1.2}
      cylinder{<-3.1,-3,1.5>,<-1.9,-3,1.5>,0.9}
    }
		prism{-0.05,0.1,5
		<-3,0>,<-3,4>,<-1,4>,<4,0>,<-3,0> //tail
		rotate -90*x}
		prism{-0.05,0.1,7
		<-3,-1>,<-3,5>,<-1,5>,<5,0>,<4,0>,<4,-1>,<-3,-1> //wing
		rotate 40*x
		translate <0,-3.8,2.8>}
		cylinder{<4,-3.8,2.8>,<7,-3.8,2.8>,0.1}
		cylinder{<4.5,-3.8,2.8>,<5.5,-3.8,2.8>,0.2}
		texture{unicolor}
	}	
	box{<1,-0.2,0>,<3,-3,0.8>
	rotate -33*z
	translate <6.5,0,0>
	finish{F_Glass4}
	pigment{color rgbf <0.6,0.6,1,0.3>}
	}
	box{<0,-0.6,0>,<4,-3,0.8>
	translate <3,0,0>
	finish{F_Glass4}
	pigment{color rgbf <0.6,0.6,1,0.3>}
	}
  union {
  	prism{0,-1.2,4
	  <16,2>,<18,2>,<16,4>,<16,2>
  	rotate 90*x}
    box{<15,-2,-0.1>,<16,-4,1.2>}
  	pigment{color rgb <0.2, 0.2, 0.2>} //dark
	}

	union{
  	cylinder{<-1,-1.2,1>,<-2,-1.2,1>,0.1}
  	cylinder{<-1,-3,2.5>,<-2,-3,2.5>,0.1}

  	cylinder{<-1,-1,1>,<-2,-1,1>,0.1}
  	cylinder{<-1,-2.8,2.5>,<-2,-2.8,2.5>,0.1}

  	cylinder{<-1,-0.8,0.9>,<-2,-0.8,0.9>,0.06}
  	cylinder{<-1,-2.6,2.4>,<-2,-2.6,2.4>,0.06}

  	cylinder{<-1,-0.6,0.8>,<-2,-0.6,0.8>,0.1}
  	cylinder{<-1,-2.4,2.3>,<-2,-2.4,2.3>,0.1}

  	cylinder{<-1,-1.2,0>,<-2,-1.2,0>,1}
  	cylinder{<-1,-3,1.5>,<-2,-3,1.5>,1}

	texture{Aluminum}
	}
}	

#declare viper = union { 
	object {halfviper}
	object { halfviper
	matrix < 1, 0, 0,
		 0, 1, 0,
		 0, 0,-1,
		 0, 0, 0 >
	}
}

#declare viperexhaust =
box { <-80,-8,-5>,<-3,4,5>
  pigment { color rgbt <1, 1, 1, 1> }
  interior{
    media {
      emission 0.07
      intervals 100
      samples 1,10
      density{spherical}
      scale <16,7,7>
      translate <-8,-2,0>
    }
    media {
      emission <0.08,0.08,0.06>
      intervals 100
      samples 1,10      
      density{spherical}
      scale <80,7,7>
      translate <-8,-2,0>
    }
  }
  hollow
}
 
